[![](https://www.coin-or.org/wordpress/wp-content/uploads/2014/08/COINOR.png)](https://www.coin-or.org)

# Cbc.jl

[![Build Status](https://github.com/jump-dev/Cbc.jl/actions/workflows/ci.yml/badge.svg?branch=master)](https://github.com/jump-dev/Cbc.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/jump-dev/Cbc.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/jump-dev/Cbc.jl)

[Cbc.jl](https://github.com/jump-dev/Cbc.jl) is a wrapper for the [COIN-OR Branch and Cut (Cbc)](https://projects.coin-or.org/Cbc)
solver.

The wrapper has two components:

 * a thin wrapper around the complete C API
 * an interface to [MathOptInterface](https://github.com/jump-dev/MathOptInterface.jl)

## Affiliation

This wrapper is maintained by the JuMP community and is not a COIN-OR project.

## Getting help

If you need help, please ask a question on the [JuMP community forum](https://jump.dev/forum).

If you have a reproducible example of a bug, please [open a GitHub issue](https://github.com/jump-dev/Cbc.jl/issues/new).

## License

`Cbc.jl` is licensed under the [MIT License](https://github.com/jump-dev/Cbc.jl/blob/master/LICENSE.md).

The underlying solver, [coin-or/Cbc](https://github.com/coin-or/Cbc), is
licensed under the [Eclipse public license](https://github.com/coin-or/Cbc/blob/master/LICENSE).

## Installation

Install Cbc using `Pkg.add`:
```julia
import Pkg
Pkg.add("Cbc")
```

In addition to installing the Cbc.jl package, this will also download and
install the Cbc binaries. You do not need to install Cbc separately.

To use a custom binary, read the [Custom solver binaries](https://jump.dev/JuMP.jl/stable/developers/custom_solver_binaries/)
section of the JuMP documentation.

## Use with JuMP

To use Cbc with JuMP, use `Cbc.Optimizer`:
```julia
using JuMP, Cbc
model = Model(Cbc.Optimizer)
set_attribute(model, "logLevel", 1)
```

## MathOptInterface API

The COIN Branch-and-Cut (Cbc) optimizer supports the following constraints and attributes.

List of supported objective functions:

 * [`MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}`](@ref)

List of supported variable types:

 * [`MOI.Reals`](@ref)

List of supported constraint types:

 * [`MOI.ScalarAffineFunction{Float64}`](@ref) in [`MOI.EqualTo{Float64}`](@ref)
 * [`MOI.ScalarAffineFunction{Float64}`](@ref) in [`MOI.GreaterThan{Float64}`](@ref)
 * [`MOI.ScalarAffineFunction{Float64}`](@ref) in [`MOI.Interval{Float64}`](@ref)
 * [`MOI.ScalarAffineFunction{Float64}`](@ref) in [`MOI.LessThan{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.EqualTo{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.GreaterThan{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.Integer`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.Interval{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.LessThan{Float64}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
 * [`MOI.VectorOfVariables`](@ref) in [`MOI.SOS1{Float64}`](@ref)
 * [`MOI.VectorOfVariables`](@ref) in [`MOI.SOS2{Float64}`](@ref)

List of supported model attributes:

 * `Cbc.Status`
 * `Cbc.SecondaryStatus`
 * [`MOI.DualStatus`](@ref)
 * [`MOI.NodeCount`](@ref)
 * [`MOI.NumberOfVariables`](@ref)
 * [`MOI.ObjectiveBound`](@ref)
 * [`MOI.ObjectiveSense`](@ref)
 * [`MOI.ObjectiveValue`](@ref)
 * [`MOI.PrimalStatus`](@ref)
 * [`MOI.RelativeGap`](@ref)
 * [`MOI.ResultCount`](@ref)
 * [`MOI.SolveTimeSec`](@ref)
 * [`MOI.TerminationStatus`](@ref)
 
List of supported optimizer attributes:

 * `Cbc.SetVariableNames`
 * [`MOI.AbsoluteGapTolerance`](@ref)
 * [`MOI.NumberOfThreads`](@ref)
 * [`MOI.RawOptimizerAttribute`](@ref)
 * [`MOI.RelativeGapTolerance`](@ref)
 * [`MOI.Silent`](@ref)
 * [`MOI.SolverName`](@ref)
 * [`MOI.SolverVersion`](@ref)
 * [`MOI.TimeLimitSec`](@ref)

List of supported variable attributes:

 * [`MOI.VariablePrimal`](@ref)
 * [`MOI.VariablePrimalStart`](@ref)
 * [`MOI.VariableName`](@ref)

List of supported constraint attributes:

 * [`MOI.ConstraintPrimal`](@ref)

## Options

Options are, unfortunately, not well documented.

The following options are likely to be the most useful:

| Parameter      | Example | Explanation                                       |
| -------------- | ------- | ------------------------------------------------- |
| `seconds`      | `60.0`  | Solution timeout limit                            |
| `logLevel`     | `2`     | Set to 0 to disable solution output               |
| `maxSolutions` | `1`     | Terminate after this many feasible solutions have been found |
| `maxNodes`     | `1`     | Terminate after this many branch-and-bound nodes have been evaluated |
| `allowableGap` | `0.05`  | Terminate after optimality gap is less than this value (on an absolute scale) |
| `ratioGap`     | `0.05`  | Terminate after optimality gap is smaller than this relative fraction |
| `threads`      | `1`     | Set the number of threads to use for parallel branch & bound |

The complete list of parameters can be found by running the `cbc` executable and
typing `?` at the prompt.

Start the `cbc` executable from Julia as follows:
```julia
using Cbc_jll
Cbc_jll.cbc() do exe
    run(`$(exe)`)
end
```

# Copyright (c) 2013: Cbc.jl contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMOIWrapper

using Test

import Cbc
import MathOptInterface as MOI

function runtests()
    is_test(name) = startswith("$(name)", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

function test_SolverName()
    @test MOI.get(Cbc.Optimizer(), MOI.SolverName()) ==
          "COIN Branch-and-Cut (Cbc)"
    return
end

function test_supports_incremental_interface()
    @test !MOI.supports_incremental_interface(Cbc.Optimizer())
    return
end

function test_runtests()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MOI.instantiate(Cbc.Optimizer; with_bridge_type = Float64),
    )
    MOI.set(model, MOI.Silent(), true)
    MOI.Test.runtests(
        model,
        MOI.Test.Config(
            exclude = Any[
                MOI.ConstraintDual,
                MOI.DualObjectiveValue,
                MOI.ConstraintBasisStatus,
                MOI.VariableBasisStatus,
            ],
        ),
        exclude = [
            # Can't prove infeasible.
            "test_conic_NormInfinityCone_INFEASIBLE",
            "test_conic_NormOneCone_INFEASIBLE",
        ],
    )
    return
end

function test_params()
    # Note: we generate a non-trivial problem to ensure that Cbc struggles to
    # find a solution at the root node.
    knapsack_model = MOI.Utilities.Model{Float64}()
    N = 100
    x = MOI.add_variables(knapsack_model, N)
    MOI.add_constraint.(knapsack_model, x, MOI.ZeroOne())
    MOI.add_constraint(
        knapsack_model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1 + sin(i) for i in 1:N], x),
            0.0,
        ),
        MOI.LessThan(10.0),
    )
    MOI.set(
        knapsack_model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([cos(i) for i in 1:N], x),
            0.0,
        ),
    )
    model = Cbc.Optimizer()
    MOI.set(model, MOI.RawOptimizerAttribute("maxSol"), 1)
    @test MOI.get(model, MOI.RawOptimizerAttribute("maxSol")) == "1"
    MOI.set(model, MOI.RawOptimizerAttribute("presolve"), "off")
    MOI.set(model, MOI.RawOptimizerAttribute("cuts"), "off")
    MOI.set(model, MOI.RawOptimizerAttribute("heur"), "off")
    MOI.set(model, MOI.RawOptimizerAttribute("logLevel"), 0)
    MOI.copy_to(model, knapsack_model)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.SOLUTION_LIMIT
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    MOI.empty!(model)
    MOI.copy_to(model, knapsack_model)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.SOLUTION_LIMIT
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(model, MOI.RelativeGap()) >= 0
    @test MOI.is_set_by_optimize(Cbc.Status())
    @test MOI.get(model, Cbc.Status()) == 1
    @test MOI.is_set_by_optimize(Cbc.SecondaryStatus())
    @test MOI.get(model, Cbc.SecondaryStatus()) == 6
    return
end

"""
    test_threads()

Test solving a model with the threads parameter set.

See issues #112 and #186.
"""
function test_threads()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MOI.instantiate(Cbc.Optimizer; with_bridge_type = Float64),
    )
    MOI.set(model, MOI.RawOptimizerAttribute("presolve"), "off")
    MOI.set(model, MOI.RawOptimizerAttribute("cuts"), "off")
    MOI.set(model, MOI.RawOptimizerAttribute("heur"), "off")
    MOI.set(model, MOI.RawOptimizerAttribute("threads"), 4)
    MOI.set(model, MOI.RawOptimizerAttribute("logLevel"), 3)
    N = 100
    x = MOI.add_variables(model, N)
    MOI.add_constraint.(model, x, MOI.ZeroOne())
    w = [1 + sin(i) for i in 1:N]
    c = [1 + cos(i) for i in 1:N]
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(w, x), 0.0),
        MOI.LessThan(10.0),
    )
    obj = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(c, x), 0.0)
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMAL
    return
end

function test_PrimalStatus()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    MOI.add_constraint(model, x, MOI.LessThan(0.0))
    cbc = Cbc.Optimizer()
    MOI.copy_to(cbc, model)
    MOI.optimize!(cbc)
    MOI.get(cbc, MOI.PrimalStatus()) == MOI.NO_SOLUTION
    return
end

function test_issue_187()
    if true
        # This test segfaults (unreliably) on all platforms
        @test_broken 1 == 2
        return
    end
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MOI.instantiate(Cbc.Optimizer; with_bridge_type = Float64),
    )
    MOI.set(model, MOI.Silent(), true)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.ZeroOne())
    @test MOI.get.(model, MOI.VariablePrimalStart(), x) == [nothing, nothing]
    MOI.set.(model, MOI.VariablePrimalStart(), x, 0.0)
    @test MOI.get.(model, MOI.VariablePrimalStart(), x) == [0.0, 0.0]
    y = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, y, MOI.ZeroOne())

    MOI.add_constraint(
        model,
        MOI.Utilities.operate(vcat, Float64, x[1], 1.0 * y[1]),
        MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.EqualTo(1.0)),
    )
    MOI.add_constraint(
        model,
        MOI.Utilities.operate(vcat, Float64, x[2], 1.0 * y[1]),
        MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.EqualTo(0.0)),
    )
    MOI.set.(model, MOI.VariablePrimalStart(), y, 0.0)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.0)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMAL
    @test ≈(sum(MOI.get(model, MOI.VariablePrimal(), x)), 1.0, atol = 1e-4)
    return
end

"""
    test_VariablePrimalStart()

Testing that VariablePrimalStart is actually applied is a little convoluted.

We formulate a MIP with various setttings turned off to avoid a trivial solve in
presolve.

Then we solve and return the optimal primal solution and the number of nodes
visited.

For the second pass, we rebuild the same MIP, but this time we pass the optimal
solution as the VariablePrimalStart, and we set maxSol=1 to force Cbc to exit
after finding a single solution. Because we passed a primal feasible point, it
should return the optimal solution after exploring 0 nodes.
"""
function test_VariablePrimalStart()
    function formulate_and_solve(start)
        model = MOI.Utilities.CachingOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
            MOI.instantiate(Cbc.Optimizer; with_bridge_type = Float64),
        )
        MOI.set(model, MOI.RawOptimizerAttribute("presolve"), "off")
        MOI.set(model, MOI.RawOptimizerAttribute("cuts"), "off")
        MOI.set(model, MOI.RawOptimizerAttribute("heur"), "off")
        MOI.set(model, MOI.RawOptimizerAttribute("logLevel"), 0)
        N = 100
        x = MOI.add_variables(model, N)
        MOI.add_constraint.(model, x, MOI.ZeroOne())
        w = [1 + sin(i) for i in 1:N]
        c = [1 + cos(i) for i in 1:N]
        if start !== nothing
            MOI.set(model, MOI.RawOptimizerAttribute("maxSol"), 1)
            MOI.set.(model, MOI.VariablePrimalStart(), x, start)
        end
        MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(w, x), 0.0),
            MOI.LessThan(10.0),
        )
        obj = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(c, x), 0.0)
        MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
        MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
        MOI.optimize!(model)
        sol = MOI.get.(model, MOI.VariablePrimal(), x)
        return sol, MOI.get(model, MOI.NodeCount())
    end
    x_sol, nodes = formulate_and_solve(nothing)
    y_sol, nodes_start = formulate_and_solve(x_sol)
    @test x_sol == y_sol
    @test nodes > 0
    @test nodes_start == 0
    return
end

function test_variable_name()
    for (name, inner) in [("abc", "abc"), ("απ", "C0000000")]
        model = MOI.Utilities.Model{Float64}()
        x = MOI.add_variable(model)
        MOI.set(model, MOI.VariableName(), x, name)
        cbc = Cbc.Optimizer()
        @test !MOI.supports(cbc, MOI.VariableName(), MOI.VariableIndex)
        MOI.set(cbc, Cbc.SetVariableNames(), true)
        @test MOI.supports(cbc, MOI.VariableName(), MOI.VariableIndex)
        index_map = MOI.copy_to(cbc, model)
        @test MOI.get(cbc, MOI.VariableName(), index_map[x]) == inner
    end
    return
end

"""
This example segfaults if variable names are set. Turn them off and check we get
a feasible solution.
"""
function test_segfault()
    src = MOI.FileFormats.MOF.Model()
    MOI.read_from_file(src, joinpath(@__DIR__, "segfault.mof.json"))
    cbc = Cbc.Optimizer()
    @test MOI.supports(cbc, Cbc.SetVariableNames())
    @test MOI.get(cbc, Cbc.SetVariableNames()) == false
    MOI.set(cbc, Cbc.SetVariableNames(), true)
    @test MOI.get(cbc, Cbc.SetVariableNames()) == true
    MOI.set(cbc, Cbc.SetVariableNames(), false)
    @test MOI.get(cbc, Cbc.SetVariableNames()) == false
    index_map = MOI.copy_to(cbc, src)
    MOI.optimize!(cbc)
    @test MOI.get(cbc, MOI.TerminationStatus()) == MOI.OPTIMAL
    return
end

function test_get_objective_sense()
    for sense in (MOI.MIN_SENSE, MOI.MAX_SENSE, MOI.FEASIBILITY_SENSE)
        model = Cbc.Optimizer()
        src = MOI.Utilities.Model{Float64}()
        MOI.set(src, MOI.ObjectiveSense(), sense)
        MOI.copy_to(model, src)
        @test MOI.get(model, MOI.ObjectiveSense()) == sense
    end
    return
end

end

TestMOIWrapper.runtests()

# Copyright (c) 2013: Cbc.jl contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Cbc

import Cbc_jll: libcbcsolver
import LinearAlgebra
import MathOptInterface as MOI
import OpenBLAS32_jll
import SparseArrays

function __init__()
    config = LinearAlgebra.BLAS.lbt_get_config()
    if !any(lib -> lib.interface == :lp64, config.loaded_libs)
        LinearAlgebra.BLAS.lbt_forward(OpenBLAS32_jll.libopenblas_path)
    end
    version_str = unsafe_string(Cbc_getVersion())
    version = if version_str == "devel"
        # Support un-released versions of Cbc. These may differ in C API
        # compatibility! Use at your own peril.
        v"2.10.5"
    else
        VersionNumber(version_str)
    end
    if !(v"2.10.0" <= version < v"2.11")
        error(
            """
            You have installed version $version of Cbc, which is not supported by
            Cbc.jl We require Cbc version 2.10. After installing Cbc 2.10, run:

                import Pkg
                Pkg.rm("Cbc")
                Pkg.add("Cbc")

            If you have a newer version of Cbc installed, changes may need to be
            made to the Julia code. Please open an issue at
            https://github.com/jump-dev/Cbc.jl.
            """,
        )
    end
    return
end

include("gen/libcbc_common.jl")
include("gen/libcbc_api.jl")
include("MOI_wrapper/MOI_wrapper.jl")

# Cbc exports all `Cbc_xxx` symbols. If you don't want all of these symbols in
# your environment, then use `import Cbc` instead of `using Cbc`.

for sym in filter(s -> startswith("$s", "Cbc_"), names(@__MODULE__, all = true))
    @eval export $sym
end

end

# Copyright (c) 2013: Cbc.jl contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Julia wrapper for header: Coin_C_defines.h
# Automatically generated using Clang.jl

# Julia wrapper for header: Cbc_C_Interface.h
# Automatically generated using Clang.jl


function Cbc_getVersion()
    ccall((:Cbc_getVersion, libcbcsolver), Cstring, ())
end

function Cbc_newModel()
    ccall((:Cbc_newModel, libcbcsolver), Ptr{Cbc_Model}, ())
end

function Cbc_setProblemName(model, array)
    ccall((:Cbc_setProblemName, libcbcsolver), Cint, (Ptr{Cbc_Model}, Cstring), model, array)
end

function Cbc_addCol(model, name, lb, ub, obj, isInteger, nz, rows, coefs)
    ccall((:Cbc_addCol, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cstring, Cdouble, Cdouble, Cdouble, UInt8, Cint, Ptr{Cint}, Ptr{Cdouble}), model, name, lb, ub, obj, isInteger, nz, rows, coefs)
end

function Cbc_addRow(model, name, nz, cols, coefs, sense, rhs)
    ccall((:Cbc_addRow, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cstring, Cint, Ptr{Cint}, Ptr{Cdouble}, UInt8, Cdouble), model, name, nz, cols, coefs, sense, rhs)
end

function Cbc_addSOS(model, numRows, rowStarts, colIndices, weights, type)
    ccall((:Cbc_addSOS, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Ptr{Cint}, Ptr{Cint}, Ptr{Cdouble}, Cint), model, numRows, rowStarts, colIndices, weights, type)
end

function Cbc_loadProblem(model, numcols, numrows, start, index, value, collb, colub, obj, rowlb, rowub)
    ccall((:Cbc_loadProblem, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cint, Ptr{CoinBigIndex}, Ptr{Cint}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}), model, numcols, numrows, start, index, value, collb, colub, obj, rowlb, rowub)
end

function Cbc_setColName(model, iColumn, name)
    ccall((:Cbc_setColName, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cstring), model, iColumn, name)
end

function Cbc_setRowName(model, iRow, name)
    ccall((:Cbc_setRowName, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cstring), model, iRow, name)
end

function Cbc_setObjSense(model, sense)
    ccall((:Cbc_setObjSense, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cdouble), model, sense)
end

function Cbc_setRowLower(model, index, value)
    ccall((:Cbc_setRowLower, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cdouble), model, index, value)
end

function Cbc_setRowUpper(model, index, value)
    ccall((:Cbc_setRowUpper, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cdouble), model, index, value)
end

function Cbc_setObjCoeff(model, index, value)
    ccall((:Cbc_setObjCoeff, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cdouble), model, index, value)
end

function Cbc_setColLower(model, index, value)
    ccall((:Cbc_setColLower, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cdouble), model, index, value)
end

function Cbc_setColUpper(model, index, value)
    ccall((:Cbc_setColUpper, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cdouble), model, index, value)
end

function Cbc_setContinuous(model, iColumn)
    ccall((:Cbc_setContinuous, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint), model, iColumn)
end

function Cbc_setInteger(model, iColumn)
    ccall((:Cbc_setInteger, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint), model, iColumn)
end

function Cbc_deleteModel(model)
    ccall((:Cbc_deleteModel, libcbcsolver), Cvoid, (Ptr{Cbc_Model},), model)
end

function Cbc_setMIPStart(model, count, colNames, colValues)
    ccall((:Cbc_setMIPStart, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Ptr{Cstring}, Ptr{Cdouble}), model, count, colNames, colValues)
end

function Cbc_setMIPStartI(model, count, colIdxs, colValues)
    ccall((:Cbc_setMIPStartI, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Ptr{Cint}, Ptr{Cdouble}), model, count, colIdxs, colValues)
end

function Cbc_clone(model)
    ccall((:Cbc_clone, libcbcsolver), Ptr{Cbc_Model}, (Ptr{Cbc_Model},), model)
end

function Cbc_problemName(model, maxNumberCharacters, array)
    ccall((:Cbc_problemName, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cstring), model, maxNumberCharacters, array)
end

function Cbc_getNumElements(model)
    ccall((:Cbc_getNumElements, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_getNumCols(model)
    ccall((:Cbc_getNumCols, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_getNumIntegers(model)
    ccall((:Cbc_getNumIntegers, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_getNumRows(model)
    ccall((:Cbc_getNumRows, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_getRowName(model, iRow, name, maxLength)
    ccall((:Cbc_getRowName, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cstring, Cint), model, iRow, name, maxLength)
end

function Cbc_getColName(model, iColumn, name, maxLength)
    ccall((:Cbc_getColName, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint, Cstring, Cint), model, iColumn, name, maxLength)
end

function Cbc_getRowNz(model, row)
    ccall((:Cbc_getRowNz, libcbcsolver), Cint, (Ptr{Cbc_Model}, Cint), model, row)
end

function Cbc_getRowIndices(model, row)
    ccall((:Cbc_getRowIndices, libcbcsolver), Ptr{Cint}, (Ptr{Cbc_Model}, Cint), model, row)
end

function Cbc_getRowCoeffs(model, row)
    ccall((:Cbc_getRowCoeffs, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model}, Cint), model, row)
end

function Cbc_getColNz(model, col)
    ccall((:Cbc_getColNz, libcbcsolver), Cint, (Ptr{Cbc_Model}, Cint), model, col)
end

function Cbc_getColIndices(model, col)
    ccall((:Cbc_getColIndices, libcbcsolver), Ptr{Cint}, (Ptr{Cbc_Model}, Cint), model, col)
end

function Cbc_getColCoeffs(model, col)
    ccall((:Cbc_getColCoeffs, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model}, Cint), model, col)
end

function Cbc_getRowRHS(model, row)
    ccall((:Cbc_getRowRHS, libcbcsolver), Cdouble, (Ptr{Cbc_Model}, Cint), model, row)
end

function Cbc_getRowSense(model, row)
    ccall((:Cbc_getRowSense, libcbcsolver), UInt8, (Ptr{Cbc_Model}, Cint), model, row)
end

function Cbc_getObjSense(model)
    ccall((:Cbc_getObjSense, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_getRowLower(model)
    ccall((:Cbc_getRowLower, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_getRowUpper(model)
    ccall((:Cbc_getRowUpper, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_getObjCoefficients(model)
    ccall((:Cbc_getObjCoefficients, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_getColLower(model)
    ccall((:Cbc_getColLower, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_getColUpper(model)
    ccall((:Cbc_getColUpper, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_isInteger(model, i)
    ccall((:Cbc_isInteger, libcbcsolver), Cint, (Ptr{Cbc_Model}, Cint), model, i)
end

function Cbc_readMps(model, filename)
    ccall((:Cbc_readMps, libcbcsolver), Cint, (Ptr{Cbc_Model}, Cstring), model, filename)
end

function Cbc_readLp(model, filename)
    ccall((:Cbc_readLp, libcbcsolver), Cint, (Ptr{Cbc_Model}, Cstring), model, filename)
end

function Cbc_writeMps(model, filename)
    ccall((:Cbc_writeMps, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cstring), model, filename)
end

function Cbc_writeLp(model, filename)
    ccall((:Cbc_writeLp, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cstring), model, filename)
end

function Cbc_setInitialSolution(model, sol)
    ccall((:Cbc_setInitialSolution, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Ptr{Cdouble}), model, sol)
end

function Cbc_getVectorStarts(model)
    ccall((:Cbc_getVectorStarts, libcbcsolver), Ptr{CoinBigIndex}, (Ptr{Cbc_Model},), model)
end

function Cbc_getIndices(model)
    ccall((:Cbc_getIndices, libcbcsolver), Ptr{Cint}, (Ptr{Cbc_Model},), model)
end

function Cbc_getElements(model)
    ccall((:Cbc_getElements, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_maxNameLength()
    ccall((:Cbc_maxNameLength, libcbcsolver), Cint, ())
end

function Cbc_printModel(model, argPrefix)
    ccall((:Cbc_printModel, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cstring), model, argPrefix)
end

function Cbc_setParameter(model, name, value)
    ccall((:Cbc_setParameter, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cstring, Cstring), model, name, value)
end

function Cbc_getAllowableGap(model)
    ccall((:Cbc_getAllowableGap, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_setAllowableGap(model, allowedGap)
    ccall((:Cbc_setAllowableGap, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cdouble), model, allowedGap)
end

function Cbc_getAllowableFractionGap(model)
    ccall((:Cbc_getAllowableFractionGap, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_setAllowableFractionGap(model, allowedFracionGap)
    ccall((:Cbc_setAllowableFractionGap, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cdouble), model, allowedFracionGap)
end

function Cbc_getAllowablePercentageGap(model)
    ccall((:Cbc_getAllowablePercentageGap, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_setAllowablePercentageGap(model, allowedPercentageGap)
    ccall((:Cbc_setAllowablePercentageGap, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cdouble), model, allowedPercentageGap)
end

function Cbc_getMaximumSeconds(model)
    ccall((:Cbc_getMaximumSeconds, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_setMaximumSeconds(model, maxSeconds)
    ccall((:Cbc_setMaximumSeconds, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cdouble), model, maxSeconds)
end

function Cbc_getMaximumNodes(model)
    ccall((:Cbc_getMaximumNodes, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_setMaximumNodes(model, maxNodes)
    ccall((:Cbc_setMaximumNodes, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint), model, maxNodes)
end

function Cbc_getMaximumSolutions(model)
    ccall((:Cbc_getMaximumSolutions, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_setMaximumSolutions(model, maxSolutions)
    ccall((:Cbc_setMaximumSolutions, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint), model, maxSolutions)
end

function Cbc_getLogLevel(model)
    ccall((:Cbc_getLogLevel, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_setLogLevel(model, logLevel)
    ccall((:Cbc_setLogLevel, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cint), model, logLevel)
end

function Cbc_getCutoff(model)
    ccall((:Cbc_getCutoff, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_setCutoff(model, cutoff)
    ccall((:Cbc_setCutoff, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, Cdouble), model, cutoff)
end

function Cbc_registerCallBack(model, userCallBack)
    ccall((:Cbc_registerCallBack, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, cbc_callback), model, userCallBack)
end

function Cbc_clearCallBack(model)
    ccall((:Cbc_clearCallBack, libcbcsolver), Cvoid, (Ptr{Cbc_Model},), model)
end

function Cbc_addCutCallback(model, cutcb, name, appData)
    ccall((:Cbc_addCutCallback, libcbcsolver), Cvoid, (Ptr{Cbc_Model}, cbc_cut_callback, Cstring, Ptr{Cvoid}), model, cutcb, name, appData)
end

function Cbc_solve(model)
    ccall((:Cbc_solve, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_getColSolution(model)
    ccall((:Cbc_getColSolution, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_getBestPossibleObjValue(model)
    ccall((:Cbc_getBestPossibleObjValue, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_bestSolution(model)
    ccall((:Cbc_bestSolution, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_numberSavedSolutions(model)
    ccall((:Cbc_numberSavedSolutions, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_savedSolution(model, whichSol)
    ccall((:Cbc_savedSolution, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model}, Cint), model, whichSol)
end

function Cbc_savedSolutionObj(model, whichSol)
    ccall((:Cbc_savedSolutionObj, libcbcsolver), Cdouble, (Ptr{Cbc_Model}, Cint), model, whichSol)
end

function Cbc_getReducedCost(model)
    ccall((:Cbc_getReducedCost, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_isAbandoned(model)
    ccall((:Cbc_isAbandoned, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isProvenOptimal(model)
    ccall((:Cbc_isProvenOptimal, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isProvenInfeasible(model)
    ccall((:Cbc_isProvenInfeasible, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isContinuousUnbounded(model)
    ccall((:Cbc_isContinuousUnbounded, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_getObjValue(model)
    ccall((:Cbc_getObjValue, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_status(model)
    ccall((:Cbc_status, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_secondaryStatus(model)
    ccall((:Cbc_secondaryStatus, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_sumPrimalInfeasibilities(model)
    ccall((:Cbc_sumPrimalInfeasibilities, libcbcsolver), Cdouble, (Ptr{Cbc_Model},), model)
end

function Cbc_numberPrimalInfeasibilities(model)
    ccall((:Cbc_numberPrimalInfeasibilities, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_checkSolution(model)
    ccall((:Cbc_checkSolution, libcbcsolver), Cvoid, (Ptr{Cbc_Model},), model)
end

function Cbc_getIterationCount(model)
    ccall((:Cbc_getIterationCount, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isNodeLimitReached(model)
    ccall((:Cbc_isNodeLimitReached, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isSecondsLimitReached(model)
    ccall((:Cbc_isSecondsLimitReached, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isSolutionLimitReached(model)
    ccall((:Cbc_isSolutionLimitReached, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isInitialSolveAbandoned(model)
    ccall((:Cbc_isInitialSolveAbandoned, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isInitialSolveProvenOptimal(model)
    ccall((:Cbc_isInitialSolveProvenOptimal, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_isInitialSolveProvenPrimalInfeasible(model)
    ccall((:Cbc_isInitialSolveProvenPrimalInfeasible, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_getRowActivity(model)
    ccall((:Cbc_getRowActivity, libcbcsolver), Ptr{Cdouble}, (Ptr{Cbc_Model},), model)
end

function Cbc_getNodeCount(model)
    ccall((:Cbc_getNodeCount, libcbcsolver), Cint, (Ptr{Cbc_Model},), model)
end

function Cbc_printSolution(model)
    ccall((:Cbc_printSolution, libcbcsolver), Cvoid, (Ptr{Cbc_Model},), model)
end

function Osi_getNumCols(osi)
    ccall((:Osi_getNumCols, libcbcsolver), Cint, (Ptr{Cvoid},), osi)
end

function Osi_getColName(osi, i, name, maxLen)
    ccall((:Osi_getColName, libcbcsolver), Cvoid, (Ptr{Cvoid}, Cint, Cstring, Cint), osi, i, name, maxLen)
end

function Osi_getColLower(osi)
    ccall((:Osi_getColLower, libcbcsolver), Ptr{Cdouble}, (Ptr{Cvoid},), osi)
end

function Osi_getColUpper(osi)
    ccall((:Osi_getColUpper, libcbcsolver), Ptr{Cdouble}, (Ptr{Cvoid},), osi)
end

function Osi_isInteger(osi, col)
    ccall((:Osi_isInteger, libcbcsolver), Cint, (Ptr{Cvoid}, Cint), osi, col)
end

function Osi_getNumRows(osi)
    ccall((:Osi_getNumRows, libcbcsolver), Cint, (Ptr{Cvoid},), osi)
end

function Osi_getRowNz(osi, row)
    ccall((:Osi_getRowNz, libcbcsolver), Cint, (Ptr{Cvoid}, Cint), osi, row)
end

function Osi_getRowIndices(osi, row)
    ccall((:Osi_getRowIndices, libcbcsolver), Ptr{Cint}, (Ptr{Cvoid}, Cint), osi, row)
end

function Osi_getRowCoeffs(osi, row)
    ccall((:Osi_getRowCoeffs, libcbcsolver), Ptr{Cdouble}, (Ptr{Cvoid}, Cint), osi, row)
end

function Osi_getRowRHS(osi, row)
    ccall((:Osi_getRowRHS, libcbcsolver), Cdouble, (Ptr{Cvoid}, Cint), osi, row)
end

function Osi_getRowSense(osi, row)
    ccall((:Osi_getRowSense, libcbcsolver), UInt8, (Ptr{Cvoid}, Cint), osi, row)
end

function Osi_getColSolution(osi)
    ccall((:Osi_getColSolution, libcbcsolver), Ptr{Cdouble}, (Ptr{Cvoid},), osi)
end

function OsiCuts_addRowCut(osiCuts, nz, idx, coef, sense, rhs)
    ccall((:OsiCuts_addRowCut, libcbcsolver), Cvoid, (Ptr{Cvoid}, Cint, Ptr{Cint}, Ptr{Cdouble}, UInt8, Cdouble), osiCuts, nz, idx, coef, sense, rhs)
end

# Copyright (c) 2013: Cbc.jl contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

import Clang
import Cbc_jll
import CoinUtils_jll

FILES = [
    (CoinUtils_jll.artifact_dir, "Coin_C_defines.h"),
    (Cbc_jll.artifact_dir, "Cbc_C_Interface.h"),
]

for (dir, file) in FILES
    cp(
        joinpath(dir, "include", "coin", file),
        joinpath(@__DIR__, file);
        force = true,
    )
end

GEN_DIR = joinpath(@__DIR__, "..", "src", "gen")

wc = Clang.init(
    headers = map(i -> joinpath(@__DIR__, i[2]), FILES),
    output_file = joinpath(GEN_DIR, "libcbc_api.jl"),
    common_file = joinpath(GEN_DIR, "libcbc_common.jl"),
    header_wrapped = (root, current) -> root == current,
    header_library = x -> "libcbcsolver",
    clang_diagnostics = true,
)

run(wc)

rm(joinpath(GEN_DIR, "LibTemplate.jl"))

# Copyright (c) 2013: Cbc.jl contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

MOI.Utilities.@product_of_sets(
    _LPProductOfSets,
    MOI.EqualTo{T},
    MOI.LessThan{T},
    MOI.GreaterThan{T},
    MOI.Interval{T},
)

MOI.Utilities.@struct_of_constraints_by_set_types(
    _CbcConstraints,
    Union{MOI.EqualTo{T},MOI.LessThan{T},MOI.GreaterThan{T},MOI.Interval{T}},
    MOI.SOS1{T},
    MOI.SOS2{T},
)

const OptimizerCache = MOI.Utilities.GenericModel{
    Float64,
    MOI.Utilities.ObjectiveContainer{Float64},
    MOI.Utilities.VariablesContainer{Float64},
    _CbcConstraints{Float64}{
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Cint,
                MOI.Utilities.ZeroBasedIndexing,
            },
            MOI.Utilities.Hyperrectangle{Float64},
            _LPProductOfSets{Float64},
        },
        MOI.Utilities.VectorOfConstraints{
            MOI.VectorOfVariables,
            MOI.SOS1{Float64},
        },
        MOI.Utilities.VectorOfConstraints{
            MOI.VectorOfVariables,
            MOI.SOS2{Float64},
        },
    },
}

"""
    Optimizer()

Create a new Cbc Optimizer.

## Variable names

By default, Cbc.jl will not pass variable names to the C model because, in some
instances, this has caused segfaults. Enable names being passed to the C model
using:
```julia
using JuMP, Cbc
model = Model(
    optimizer_with_attributes(Cbc.Optimizer, Cbc.SetVariableNames() => true),
)
```
"""
mutable struct Optimizer <: MOI.AbstractOptimizer
    inner::Ptr{Cvoid}
    silent::Bool
    params::Dict{String,String}
    variable_start::Dict{MOI.VariableIndex,Float64}
    objective_constant::Float64
    solve_time::Float64
    Cbc_solve_return_code::Cint
    termination_status::MOI.TerminationStatusCode
    has_solution::Bool
    variable_primal::Union{Nothing,Vector{Float64}}
    constraint_primal::Union{Nothing,Vector{Float64}}
    set_names::Bool
    function Optimizer()
        model = new(
            Cbc_newModel(),
            false,
            Dict{String,String}(),
            Dict{MOI.VariableIndex,Float64}(),
            0.0,
            0.0,
            Cint(-1),
            MOI.OPTIMIZE_NOT_CALLED,
            false,
            nothing,
            nothing,
            false,
        )
        finalizer(Cbc_deleteModel, model)
        return model
    end
end

Base.cconvert(::Type{Ptr{Cvoid}}, model::Optimizer) = model
Base.unsafe_convert(::Type{Ptr{Cvoid}}, model::Optimizer) = model.inner

function MOI.default_cache(::Optimizer, ::Type{Float64})
    return MOI.Utilities.UniversalFallback(OptimizerCache())
end

struct SetVariableNames <: MOI.AbstractOptimizerAttribute end

MOI.supports(::Optimizer, ::SetVariableNames) = true

function MOI.set(model::Optimizer, ::SetVariableNames, flag::Bool)
    model.set_names = flag
    return
end

MOI.get(model::Optimizer, ::SetVariableNames) = model.set_names

function MOI.supports(::Optimizer, ::MOI.RawOptimizerAttribute)
    # TODO(odow): There is no programatical way throught the C API to check if a
    # parameter name (or value) is valid. Fix this upstream.
    return true
end

function MOI.set(model::Optimizer, param::MOI.RawOptimizerAttribute, value)
    return MOI.set(model, param, string(value))
end

function MOI.set(
    model::Optimizer,
    param::MOI.RawOptimizerAttribute,
    value::String,
)
    model.params[param.name] = value
    if param.name == "threads" && Sys.iswindows()
        @warn(
            "Ignoring threads parameter due to known bugs in CBC. Read " *
            "https://github.com/jump-dev/Cbc.jl/issues/186 for more details.",
        )
        return
    end
    if !(model.silent && param.name == "logLevel")
        Cbc_setParameter(model, param.name, value)
    end
    return
end

function MOI.get(model::Optimizer, param::MOI.RawOptimizerAttribute)
    # TODO: This gives a poor error message if the name of the parameter is
    # invalid.
    return model.params[param.name]
end

MOI.supports(::Optimizer, ::MOI.Silent) = true

function MOI.set(model::Optimizer, ::MOI.Silent, value::Bool)
    if value == model.silent
        return
    end
    log_level = value ? "0" : get(model.params, "logLevel", "1")
    Cbc_setParameter(model, "logLevel", log_level)
    model.silent = value
    return
end
MOI.get(model::Optimizer, ::MOI.Silent) = model.silent

MOI.supports(::Optimizer, ::MOI.TimeLimitSec) = true
function MOI.set(model::Optimizer, ::MOI.TimeLimitSec, value)
    if value === nothing
        delete!(model.params, "seconds")
        Cbc_setParameter(model, "seconds", "??")
    else
        MOI.set(model, MOI.RawOptimizerAttribute("seconds"), value)
    end
    return
end

function MOI.get(model::Optimizer, ::MOI.TimeLimitSec)
    value = get(model.params, "seconds", nothing)
    return value === nothing ? value : parse(Float64, value)
end

MOI.supports(::Optimizer, ::MOI.NumberOfThreads) = true

function MOI.set(model::Optimizer, ::MOI.NumberOfThreads, value::Integer)
    MOI.set(model, MOI.RawOptimizerAttribute("threads"), value)
    return
end

function MOI.set(model::Optimizer, ::MOI.NumberOfThreads, ::Nothing)
    delete!(model.params, "threads")
    Cbc_setParameter(model, "threads", "InvalidIntValue")
    return
end

function MOI.get(model::Optimizer, ::MOI.NumberOfThreads)
    value = get(model.params, "threads", nothing)
    return value === nothing ? value : parse(Int, value)
end

MOI.supports(::Optimizer, ::MOI.AbsoluteGapTolerance) = true

function MOI.set(model::Optimizer, ::MOI.AbsoluteGapTolerance, value::Real)
    MOI.set(model, MOI.RawOptimizerAttribute("allowableGap"), value)
    return
end

function MOI.set(model::Optimizer, ::MOI.AbsoluteGapTolerance, ::Nothing)
    delete!(model.params, "allowableGap")
    Cbc_setParameter(model, "allowableGap", "InvalidDoubleValue")
    return
end

function MOI.get(model::Optimizer, ::MOI.AbsoluteGapTolerance)
    value = get(model.params, "allowableGap", nothing)
    return value === nothing ? value : parse(Float64, value)
end

MOI.supports(::Optimizer, ::MOI.RelativeGapTolerance) = true

function MOI.set(model::Optimizer, ::MOI.RelativeGapTolerance, value::Real)
    MOI.set(model, MOI.RawOptimizerAttribute("ratioGap"), value)
    return
end

function MOI.set(model::Optimizer, ::MOI.RelativeGapTolerance, ::Nothing)
    delete!(model.params, "ratioGap")
    Cbc_setParameter(model, "ratioGap", "InvalidDoubleValue")
    return
end

function MOI.get(model::Optimizer, ::MOI.RelativeGapTolerance)
    value = get(model.params, "ratioGap", nothing)
    return value === nothing ? value : parse(Float64, value)
end

MOI.get(::Optimizer, ::MOI.SolverName) = "COIN Branch-and-Cut (Cbc)"

MOI.get(::Optimizer, ::MOI.SolverVersion) = unsafe_string(Cbc_getVersion())

function MOI.empty!(model::Optimizer)
    Cbc_deleteModel(model)
    model.inner = Cbc_newModel()
    model.objective_constant = 0.0
    model.Cbc_solve_return_code = Cint(-1)
    model.termination_status = MOI.OPTIMIZE_NOT_CALLED
    model.solve_time = 0.0
    for (name, value) in model.params
        MOI.set(model, MOI.RawOptimizerAttribute(name), value)
    end
    if model.silent
        Cbc_setParameter(model, "logLevel", "0")
    end
    empty!(model.variable_start)
    model.has_solution = false
    model.variable_primal = nothing
    model.constraint_primal = nothing
    return
end

function MOI.is_empty(model::Optimizer)
    return Cbc_getNumCols(model) == 0 && Cbc_getNumRows(model) == 0
end

function _index_map(
    src::OptimizerCache,
    ::MOI.IndexMap,
    ci::MOI.ConstraintIndex{<:MOI.ScalarAffineFunction},
)
    return MOI.Utilities.rows(src.constraints.moi_equalto, ci)
end

function _index_map(
    ::OptimizerCache,
    index_map::MOI.IndexMap,
    ci::MOI.ConstraintIndex{<:MOI.VariableIndex},
)
    return index_map[MOI.VariableIndex(ci.value)].value
end

function _index_map(
    ::OptimizerCache,
    ::MOI.IndexMap,
    ci::MOI.ConstraintIndex{<:MOI.VectorOfVariables},
)
    return ci.value
end

function _index_map(
    src::OptimizerCache,
    index_map::MOI.IndexMap,
    ::Type{F},
    ::Type{S},
) where {F,S}
    inner = index_map.con_map[F, S]
    for ci in MOI.get(src, MOI.ListOfConstraintIndices{F,S}())
        inner[ci] = MOI.ConstraintIndex{F,S}(_index_map(src, index_map, ci))
    end
    return
end

"""
    _index_map(src::OptimizerCache)

Create an `IndexMap` mapping the variables and constraints in `OptimizerCache`
to their corresponding 1-based columns and rows.
"""
function _index_map(src::OptimizerCache)
    index_map = MOI.IndexMap()
    for (i, x) in enumerate(MOI.get(src, MOI.ListOfVariableIndices()))
        index_map[x] = MOI.VariableIndex(i)
    end
    for (F, S) in MOI.get(src, MOI.ListOfConstraintTypesPresent())
        _index_map(src, index_map, F, S)
    end
    return index_map
end

function _constraint_matrix(constraints, n)
    @assert n == constraints.coefficients.n
    return (
        m = constraints.coefficients.m,
        n = constraints.coefficients.n,
        colptr = constraints.coefficients.colptr,
        rowval = constraints.coefficients.rowval,
        nzval = constraints.coefficients.nzval,
        lower = constraints.constants.lower,
        upper = constraints.constants.upper,
    )
end

function _constraint_matrix(::Nothing, n)
    return (
        m = Cint(0),
        n = Cint(n),
        colptr = fill(Cint(0), n + 1),
        rowval = Cint[],
        nzval = Float64[],
        lower = Float64[],
        upper = Float64[],
    )
end

function MOI.copy_to(dest::Optimizer, src::OptimizerCache)
    matrix = _constraint_matrix(
        src.constraints.moi_equalto,
        MOI.get(src, MOI.NumberOfVariables()),
    )
    c = zeros(matrix.n)
    obj =
        MOI.get(src, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}())
    for term in obj.terms
        c[term.variable.value] += term.coefficient
    end
    dest.objective_constant = obj.constant
    zeroone_attr = MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne}()
    binaries = Cint[Cint(ci.value - 1) for ci in MOI.get(src, zeroone_attr)]
    variable_lower = copy(src.variables.lower)
    variable_upper = copy(src.variables.upper)
    for b in binaries
        variable_lower[b+1] = max(variable_lower[b+1], 0.0)
        variable_upper[b+1] = min(variable_upper[b+1], 1.0)
    end
    Cbc_loadProblem(
        dest,
        matrix.n,
        matrix.m,
        matrix.colptr,
        matrix.rowval,
        matrix.nzval,
        variable_lower,
        variable_upper,
        c,
        matrix.lower,
        matrix.upper,
    )
    sense = MOI.get(src, MOI.ObjectiveSense())
    if sense == MOI.MIN_SENSE
        Cbc_setObjSense(dest, 1)
    elseif sense == MOI.MAX_SENSE
        Cbc_setObjSense(dest, -1)
    else
        @assert sense == MOI.FEASIBILITY_SENSE
        Cbc_setObjSense(dest, 0)
    end
    Cbc_setInteger.(dest, binaries)
    attr = MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Integer}()
    for ci in MOI.get(src, attr)
        Cbc_setInteger(dest, Cint(ci.value - 1))
    end
    if MOI.VariableName() in MOI.get(src, MOI.ListOfVariableAttributesSet()) &&
       MOI.get(dest, SetVariableNames())::Bool
        for x in MOI.get(src, MOI.ListOfVariableIndices())
            name = MOI.get(src, MOI.VariableName(), x)
            if !isempty(name) && isascii(name)
                MOI.set(dest, MOI.VariableName(), x, name)
            end
        end
    end
    for (S, type) in ((MOI.SOS1{Float64}, 1), (MOI.SOS2{Float64}, 2))
        starts, indices, weights = Cint[], Cint[], Float64[]
        attr = MOI.ListOfConstraintIndices{MOI.VectorOfVariables,S}()
        for ci in MOI.get(src, attr)
            push!(starts, Cint(length(weights)))
            f = MOI.get(src, MOI.ConstraintFunction(), ci)
            for x in f.variables
                push!(indices, Cint(x.value - 1))
            end
            s = MOI.get(src, MOI.ConstraintSet(), ci)
            append!(weights, s.weights)
        end
        N = Cint(length(starts))
        if N > 0
            push!(starts, length(weights))
            Cbc_addSOS(dest, N, starts, indices, weights, Cint(type))
        end
    end
    return _index_map(src)
end

function MOI.copy_to(
    dest::Optimizer,
    src::MOI.Utilities.UniversalFallback{OptimizerCache},
)
    attr = MOI.VariablePrimalStart()
    MOI.Utilities.throw_unsupported(
        src;
        excluded_attributes = Any[MOI.VariablePrimalStart()],
    )
    index_map = MOI.copy_to(dest, src.model)
    if attr in MOI.get(src, MOI.ListOfVariableAttributesSet())
        for (x_src, x_dest) in index_map.var_map
            value = MOI.get(src, attr, x_src)
            MOI.set(dest, attr, x_dest, value)
        end
    end
    return index_map
end

function MOI.copy_to(dest::Optimizer, src::MOI.ModelLike)
    cache = MOI.default_cache(dest, Float64)
    src_cache = MOI.copy_to(cache, src)
    cache_dest = MOI.copy_to(dest, cache)
    index_map = MOI.IndexMap()
    for (src_x, cache_x) in src_cache.var_map
        index_map[src_x] = cache_dest[cache_x]
    end
    for (src_ci, cache_ci) in src_cache.con_map
        index_map[src_ci] = cache_dest[cache_ci]
    end
    return index_map
end

###
### supports and supports_constraint
###

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VariableIndex},
    ::Type{
        <:Union{
            MOI.EqualTo{Float64},
            MOI.LessThan{Float64},
            MOI.GreaterThan{Float64},
            MOI.Interval{Float64},
            MOI.ZeroOne,
            MOI.Integer,
        },
    },
)
    return true
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VectorOfVariables},
    ::Type{<:Union{MOI.SOS1{Float64},MOI.SOS2{Float64}}},
)
    return true
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.ScalarAffineFunction{Float64}},
    ::Type{
        <:Union{
            MOI.EqualTo{Float64},
            MOI.LessThan{Float64},
            MOI.GreaterThan{Float64},
            MOI.Interval{Float64},
        },
    },
)
    return true
end

MOI.supports(::Optimizer, ::MOI.ObjectiveSense) = true

function MOI.supports(
    ::Optimizer,
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}},
)
    return true
end

###
### Variable starting values
###

function MOI.supports(
    ::Optimizer,
    ::MOI.VariablePrimalStart,
    ::Type{MOI.VariableIndex},
)
    return true
end

function MOI.set(
    model::Optimizer,
    ::MOI.VariablePrimalStart,
    x::MOI.VariableIndex,
    ::Nothing,
)
    delete!(model.variable_start, x)
    return
end

function MOI.set(
    model::Optimizer,
    ::MOI.VariablePrimalStart,
    x::MOI.VariableIndex,
    value,
)
    model.variable_start[x] = value
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.VariablePrimalStart,
    x::MOI.VariableIndex,
)
    return get(model.variable_start, x, nothing)
end

###
### VariableName
###

function MOI.supports(
    model::Optimizer,
    ::MOI.VariableName,
    ::Type{MOI.VariableIndex},
)
    return model.set_names
end

function MOI.set(
    model::Optimizer,
    ::MOI.VariableName,
    x::MOI.VariableIndex,
    name::String,
)
    @assert isascii(name)
    if MOI.get(model, SetVariableNames())
        Cbc_setColName(model, Cint(x.value - 1), name)
    end
    return
end

function MOI.get(model::Optimizer, ::MOI.VariableName, x::MOI.VariableIndex)
    max_length = 512
    name = Vector{Cchar}(undef, max_length)
    GC.@preserve name begin
        ptr = Cstring(pointer(name))
        Cbc_getColName(model, Cint(x.value - 1), ptr, max_length)
        return unsafe_string(ptr)
    end
end

###
### Optimize and post-optimize functions
###

function MOI.optimize!(model::Optimizer)
    if !isempty(model.variable_start)
        columns = fill(Cint(0), length(model.variable_start))
        values = fill(0.0, length(model.variable_start))
        for (i, (variable, value)) in enumerate(model.variable_start)
            columns[i] = Cint(variable.value - 1)
            values[i] = value
        end
        Cbc_setMIPStartI(model, length(columns), columns, values)
    end
    t = time()
    model.variable_primal = nothing
    model.constraint_primal = nothing
    model.Cbc_solve_return_code = Cbc_solve(model)
    model.has_solution = _result_count(model)
    model.solve_time = time() - t
    model.termination_status = _termination_status(model)
    return
end

MOI.get(model::Optimizer, ::MOI.SolveTimeSec) = model.solve_time

function MOI.get(model::Optimizer, ::MOI.NumberOfVariables)
    return Cbc_getNumCols(model)
end

function MOI.get(model::Optimizer, ::MOI.ObjectiveBound)
    if Cbc_getNumIntegers(model) == 0
        return MOI.get(model, MOI.ObjectiveValue())
    end
    return Cbc_getBestPossibleObjValue(model) + model.objective_constant
end

function MOI.get(model::Optimizer, ::MOI.NodeCount)::Int64
    return Cbc_getNodeCount(model)
end

function MOI.get(model::Optimizer, attr::MOI.ObjectiveValue)
    MOI.check_result_index_bounds(model, attr)
    return Cbc_getObjValue(model) + model.objective_constant
end

# Cbc does not provide a native way of accessing the relative gap,
# use the Gurobi convention instead.
function MOI.get(model::Optimizer, ::MOI.RelativeGap)
    incumbent = MOI.get(model, MOI.ObjectiveValue())
    bound = MOI.get(model, MOI.ObjectiveBound())
    gap = abs(bound - incumbent) / abs(incumbent)
    return isnan(gap) ? Inf : gap
end

_update_cache(::Optimizer, data::Vector{Float64}, ::Any, ::Any) = data

function _update_cache(model::Optimizer, ::Nothing, f_p::F, f_n::G) where {F,G}
    p = f_p(model)
    n = f_n(model)
    if p == C_NULL
        return fill(NaN, n)
    end
    return unsafe_wrap(Array, p, (n,))
end

_get_cached_solution(data::Vector{Float64}, x) = data[x.value]

function _get_cached_solution(data::Vector{Float64}, x::Vector)
    return [data[xi.value] for xi in x]
end

function MOI.get(
    model::Optimizer,
    attr::MOI.VariablePrimal,
    x::Union{MOI.VariableIndex,Vector{MOI.VariableIndex}},
)
    MOI.check_result_index_bounds(model, attr)
    model.variable_primal = _update_cache(
        model,
        model.variable_primal,
        Cbc_getColSolution,
        Cbc_getNumCols,
    )
    return _get_cached_solution(model.variable_primal, x)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    c::MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},<:Any},
)
    MOI.check_result_index_bounds(model, attr)
    model.constraint_primal = _update_cache(
        model,
        model.constraint_primal,
        Cbc_getRowActivity,
        Cbc_getNumRows,
    )
    return _get_cached_solution(model.constraint_primal, c)
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    index::MOI.ConstraintIndex{MOI.VariableIndex,<:Any},
)
    MOI.check_result_index_bounds(model, attr)
    return MOI.get(model, MOI.VariablePrimal(), MOI.VariableIndex(index.value))
end

function MOI.get(model::Optimizer, ::MOI.ObjectiveSense)
    sense = Cbc_getObjSense(model)
    if sense == 1.0
        return MOI.MIN_SENSE
    elseif sense == -1.0
        return MOI.MAX_SENSE
    else
        @assert sense == 0.0
        return MOI.FEASIBILITY_SENSE
    end
end

struct Status <: MOI.AbstractModelAttribute end
MOI.is_set_by_optimize(::Status) = true

struct SecondaryStatus <: MOI.AbstractModelAttribute end
MOI.is_set_by_optimize(::SecondaryStatus) = true

MOI.get(model::Optimizer, ::Status) = Cbc_status(model)
MOI.get(model::Optimizer, ::SecondaryStatus) = Cbc_secondaryStatus(model)

const _STATUS = Dict{Cint,String}(
    Cint(-1) => "before branchAndBound",
    Cint(0) =>
        "finished - check isProvenOptimal or isProvenInfeasible to see if " *
        "solution found (or check value of best solution)",
    Cint(1) => "stopped - on maxnodes, maxsols, maxtime",
    Cint(2) => "execution abandoned due to numerical dificulties",
    Cint(5) => "user programmed interruption",
)

const _SECONDARY_STATUS = Dict{Cint,String}(
    Cint(-1) => "unset (status_ will also be -1)",
    Cint(0) => "search completed with solution",
    Cint(1) => "linear relaxation not feasible (or worse than cutoff)",
    Cint(2) => "stopped on gap",
    Cint(3) => "stopped on nodes",
    Cint(4) => "stopped on time",
    Cint(5) => "stopped on user event",
    Cint(6) => "stopped on solutions",
    Cint(7) => "linear relaxation unbounded",
    Cint(8) => "stopped on iteration limit",
)

function MOI.get(model::Optimizer, ::MOI.RawStatusString)
    return """
    Cbc_status          = $(_STATUS[model.Cbc_solve_return_code])
    Cbc_secondaryStatus = $(_SECONDARY_STATUS[Cbc_secondaryStatus(model)])
    """
end

MOI.get(model::Optimizer, ::MOI.ResultCount) = model.has_solution ? 1 : 0

function _result_count(model::Optimizer)
    if Cbc_getNumIntegers(model) == 0
        # Cbc forwards the solve to the LP solver if there are no integers, so
        # check the termination status for the result count.
        return model.Cbc_solve_return_code == 0 ? 1 : 0
    end
    return Cbc_numberSavedSolutions(model) > 0 ? 1 : 0
end

MOI.get(model::Optimizer, ::MOI.TerminationStatus) = model.termination_status

function _termination_status(model::Optimizer)
    status = model.Cbc_solve_return_code
    if status == -1
        return MOI.OPTIMIZE_NOT_CALLED
    elseif Cbc_isProvenOptimal(model) != 0
        return MOI.OPTIMAL
    elseif Cbc_isProvenInfeasible(model) != 0
        if Cbc_getNumIntegers(model) == 0
            # Why Cbc. For LPs, this could mean dual infeasible.
            return MOI.INFEASIBLE_OR_UNBOUNDED
        else
            return MOI.INFEASIBLE
        end
    elseif Cbc_isContinuousUnbounded(model) != 0
        return MOI.INFEASIBLE_OR_UNBOUNDED
    elseif Cbc_isNodeLimitReached(model) != 0
        return MOI.NODE_LIMIT
    elseif Cbc_isSecondsLimitReached(model) != 0
        return MOI.TIME_LIMIT
    elseif Cbc_isSolutionLimitReached(model) != 0
        return MOI.SOLUTION_LIMIT
    elseif status == 0
        return MOI.OTHER_ERROR
    elseif status == 1
        return MOI.OTHER_LIMIT
    elseif status == 2
        return MOI.NUMERICAL_ERROR
    else
        @assert status == 5
        return MOI.INTERRUPTED
    end
end

function MOI.get(model::Optimizer, attr::MOI.PrimalStatus)
    if attr.result_index != 1
        return MOI.NO_SOLUTION
    elseif MOI.get(model, MOI.ResultCount()) == 1
        return MOI.FEASIBLE_POINT
    else
        return MOI.NO_SOLUTION
    end
end

function MOI.get(::Optimizer, ::MOI.DualStatus)
    return MOI.NO_SOLUTION
end

# Copyright (c) 2013: Cbc.jl contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Automatically generated using Clang.jl


const Clp_Simplex = Cvoid
const clp_callback = Ptr{Cvoid}
const Sbb_Model = Cvoid
const Cbc_Model = Cvoid
const sbb_callback = Ptr{Cvoid}
const cbc_callback = Ptr{Cvoid}
const cbc_cut_callback = Ptr{Cvoid}
const CoinBigIndex = Cint
